<template>

  <div>
    <!-- Table Container Card -->
    <b-card
    >

      <div class="m-2">

        <!-- Table Top -->
        <b-row>

           <!-- Search -->
          <b-col
            cols="12"
            md="6"
            class="d-flex align-items-center justify-content-start mb-1 mb-md-0"
          >
             <b-form-input
                v-model="searchQuery"
                class="d-inline-block mr-1"
                placeholder="Search..."
              />
          </b-col>
          <!-- Add client button -->
          <b-col
            cols="12"
            md="6"
          >
            <div class="d-flex align-items-center justify-content-end">
             
              <b-button
                variant="primary"
                @click="$router.push({ name: 'apps-clients-create' })"
              >
                <span class="text-nowrap">Agregar cliente</span>
              </b-button>
            </div>
          </b-col>
        </b-row>

      </div>

      <b-table
        ref="refUserListTable"
        class="position-relative"
        :items="clients"
        responsive
        :fields="tableColumns"
        :filter="searchQuery"
        primary-key="id"
        show-empty
        sticky-header
        empty-text="No se econtraron registros"
      
      >

        <!-- Column: Actions -->
        <template #cell(actions)="data">
          <div variant="link"
            no-caret
            text-center
            :right="$store.state.appConfig.isRTL">
            <b-button variant="outline" :to="{ name: 'apps-clients-view', params: { id:  data.item.id} }"><feather-icon icon="FileTextIcon" /> Detalles</b-button>
            <b-button variant="outline" :to="{ name: 'apps-clients-edit', params: { id: data.item.id } }"><feather-icon icon="EditIcon" /> Editar</b-button>
            <b-button variant="outline" @click="deleteClient(data.item.id)"><feather-icon icon="TrashIcon" /> Eliminar</b-button>
          </div> 
        
        </template> 
      

      </b-table>
      <div class="mx-2 mb-2">
        <b-row>

          <b-col
            cols="12"
            sm="6"
            class="d-flex align-items-center justify-content-center justify-content-sm-start"
          >
   
          </b-col>
         

        </b-row>
      </div>
    </b-card>
  </div>
</template>

<script>
import {
  BCard, BRow, BCol, BFormInput, BButton, BTable, BMedia, BAvatar, BLink,
  BBadge, BDropdown, BDropdownItem, BPagination,
} from 'bootstrap-vue'
import vSelect from 'vue-select'

export default {
  components: {

    BCard,
    BRow,
    BCol,
    BFormInput,
    BButton,
    BTable,
    BMedia,
    BAvatar,
    BLink,
    BBadge,
    BDropdown,
    BDropdownItem,
    BPagination,

    vSelect,
  },
  data(){
    return {
      clients:[],
      tableColumns:[
        { key: 'name',label:'Nombre', sortable: true },
        { key: 'rfc',label:'RFC', sortable: true },
      
        { key: 'actions',label:'Acciones',class:'text-center' },
      ],
      searchQuery:'',


    }
  },
  methods:{
    getClients(){
      this.$http.get('clients').then(res=>{
        this.clients = res.data.clients
      }).catch(err=>{
        console.log(err)
      })
    },
    deleteClient(client){
      this.$swal({
        title: '¿Está seguro de eliminar el registro?',
        text: "No podrás revertir esto!",
        icon: 'warning',
        showCancelButton: true,
        confirmButtonText: 'Si, eliminar!',
        customClass: {
          confirmButton: 'btn btn-primary',
          cancelButton: 'btn btn-outline-danger ml-1',
        },
        buttonsStyling: false,

      }).then(result => {
        if (result.value) {
          this.$http.get('clients/delete',{params:{id:client}}).then(res=>{
            if(res.data.message === 'deleted'){
              this.$swal({
                  icon: 'success',
                  title: 'Eliminado!',
                  text: 'El registro ha sido eliminado.',
                  customClass: {
                    confirmButton: 'btn btn-success',
                  },
                })
              this.getClients()
            }else if(res.data.message === 'haveProjects'){
              this.$swal({
                title: 'Error',
                text: 'Este cliente tiene asignado uno o más proyectos, no se puede eliminar',
                icon: 'error',
                customClass: {
                  confirmButton: 'btn btn-success',
                },
              })
            }
          }).catch(err=>{
            console.log(err)
          })
      } else {
          this.$swal({
            title: 'Cancelado',
            text: 'El registro esta a salvo :)',
            icon: 'error',
            customClass: {
              confirmButton: 'btn btn-success',
            },
          })
        }
    })
    }
    
  },
  mounted(){
    this.getClients()

  },


}
</script>

<style lang="scss" scoped>
.per-page-selector {
  width: 90px;
}
</style>

<style lang="scss">
@import '@core/scss/vue/libs/vue-select.scss';
</style>
